<template>
    <div>
        <b-navbar toggleable="lg" type="dark" class="bg-sgm-navbar" fixed="top">
            <b-navbar-brand :to="urlHome">{{siglaSistema}}</b-navbar-brand>
            <b-navbar-toggle target="nav-collapse"></b-navbar-toggle>
            <b-collapse id="nav-collapse" is-nav v-if="menuVisivel">
                <b-navbar-nav>
                    <b-nav-item-dropdown
                        v-for="item in modulosPermitidos" :key="item.codigo">
                        <template slot="button-content">
                            <b-icon :icon="item.icone" class="color-white"/> 
                            <span class="color-white ml-2">{{item.descricao}}</span>
                        </template>
                        <span v-for="link in item.links" :key="link.nome">
                            <b-dropdown-item :to=link.url >{{link.nome}}</b-dropdown-item>
                        </span>
                    </b-nav-item-dropdown>
                </b-navbar-nav>

                <!-- Right aligned nav items -->
                <b-navbar-nav class="ml-auto">
                    <b-nav-item-dropdown right>
                    <!-- Using 'button-content' slot -->
                    <template #button-content>
                        <b-icon icon="person-circle" class="color-white"/>
                        <span class="color-white ml-2">{{nomeUsuario}}</span>
                    </template>
                    <b-dropdown-item to="/auth/profile">Minha Conta</b-dropdown-item>
                    <b-dropdown-item @click="logout">Sair</b-dropdown-item>
                    </b-nav-item-dropdown>
                </b-navbar-nav>
            </b-collapse>
        </b-navbar>
    </div>
</template>

<script>
import Modulos from '../../modulos.js'
import axios from 'axios'

export default {
    name:"SgmNabBar",
    props: {
        menuVisivel: {
            type:Boolean,
            default: false
        }
    },
    data: function(){
        return {
            siglaSistema:'SGM',
            Modulos
        }
    },
    computed: {
        nomeUsuario() {
            return this.$store.getters.username
        },
        modulosPermitidos() {
            let roles = this.$store.getters.roles
            if (!roles) { return [] }
            let modulosPermitidos = Modulos.filter(m => {
                let rolesInterception = roles.filter(r => m.roles.indexOf(r) >= 0)
                return rolesInterception.length > 0
            })
            return  modulosPermitidos
        },        
        urlHome() {
            return this.$props.menuVisivel ? "/auth": "/"
        }
    },
    methods: {
        logout() {
            const token = this.$store.getters.token
            if(token) {
                const config = {headers:{ Authorization: token }}
                axios
                    .get("http://localhost:5555/identity/oauth/logout", config)
                        .then(() => this.$router.push("/"))
                        .catch((err)=> {
                            let message = 'Erro ao tentar sair do sistema'
                            if(err.message) { message = err.message}
                            this.$toastr.e(message)
                        })
                        .finally(()=> this.$store.commit('DESLOGAR_USUARIO'))
            }            
        }
    }  
}
</script>

<style scoped>
    .bg-sgm-navbar {
        background-color:#0061ae;
    }
    .color-white {
        color: aliceblue;
    }
</style>